<?php defined('SYSPATH') || die('No direct script access.');

class Controller_Office_Export extends Controller_Environment_Office
{

    public function before() {
        parent::before();
        Cookie::set('fD', 'true');
    }

    //public function action_show() {
    public function action_index() {
        $semesterID = User::instance()->SemesterID;

        $faculty = Model_Faculty::with(User::instance()->Faculty->ID);

        $grades = Model_Grades::loadAll()->as_array();
        $groupsByGrade = array();
        foreach($grades as $grade) {
            $groups = $faculty->getGroups($grade["ID"], $semesterID);
            $group = array(
                "groups" => $groups,
                "degree" => $grade["Degree"],
                "grade_num" => $grade["Num"],
                "grade_id" => $grade["ID"]
            );
            array_push($groupsByGrade, $group);
        }

        $config = Kohana::$config->load('sync.syncDaemon');
        $service_url = $config['url'];

        $this->twig->set_filename(static::OFFICE . '/reports/export')
            ->set([
                'api_url' => $service_url,
                'groups_tree' => $groupsByGrade,
            ]);
    }

    public function action_show() {
        $semesterID = User::instance()->SemesterID;
        //$facultyID = User::instance()->Faculty->ID;
        $groupID = $this->request->post('groupID');

        $students = Model_Students::ofGroup($groupID, $semesterID);

        // TODO: refactor after new groups implemented
        $disciplines = Model_Group::with($groupID)->getDisciplines(false, $semesterID);
        $disciplines = Arr::groupByUniqueKey('ID', $disciplines);
        //$discWithCompounds = self::processCompounds($disciplines);

        $this->twig->set_filename(static::OFFICE . 'export')
            ->set([
                'Disciplines'   => $disciplines,
            ]);
    }
}
